<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline>
      <el-form-item>
        <el-input
          v-model="searchForm.supplierName"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="tableList">
      <el-table-column prop="supplierName" label="供应商名称" />
      <el-table-column prop="wechatGroup" label="微信群名称" />
      <el-table-column label="状态" min-width="150" prop="status">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column prop="remark" label="备注" />
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="操作">
        <template #default="scope">
          <el-button type="primary" text @click="openForm('update', scope.row.id)">修改</el-button>
          <el-button type="danger" text @click="handleDelete(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="getList"
    />

    <DialogSupplier ref="brandDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="SupplierSet">
import { dateFormatter } from '@/utils/formatTime'
import DialogSupplier from './DialogSupplier.vue'
import * as SupplierApi from '@/api/school/setting/supplier'
import { DICT_TYPE } from '@/utils/dict'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const searchForm = ref({
  supplierName: '',
  pageSize: 20,
  pageNo: 1
})

const total = ref(0)
const brandDialog = ref()
const tableList = ref([])
const loading = ref(false)

function handleQuery() {
  searchForm.value.pageNo = 1
  getList()
}
function resetQuery() {
  searchForm.value = {
    supplierName: '',
    pageSize: 20,
    pageNo: 1
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await SupplierApi.getSupplierPage(searchForm.value)
    tableList.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

function openForm(type, id) {
  brandDialog.value.open(type, id)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await SupplierApi.deleteSupplier(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

onMounted(() => {
  handleQuery()
})
</script>

<style lang="scss" scoped></style>
